#include <vector>
#include <string>
#include <set>
#include "testlib.h"
#include <iostream>
using namespace std;


double score_test() {
    int n = inf.readInt(1, 10000, "n");
    int m = inf.readInt(1, 100, "m");
    vector<vector<int>> usage(m);
    for (int i = 0; i < m; i++) {
        int k = inf.readInt(1, n, "k_" + to_string(i+1));
        while (k--) {
            int x = inf.readInt(1, n, "a" + to_string(-k) + "_" + to_string(i));
            usage[i].push_back(x - 1);
        }
    }
    int ja = 0;
    vector<bool> used(n, false);
    int pa = 0;
    int p_num = ouf.readInt(1, m, "ans");
    vector<int> sets;
    for (int i = 0; i < p_num; i++) {
        int x = ouf.readInt(1, m, "ans_" + to_string(i + 1)) - 1;
        sets.push_back(x);
        for (auto e : usage[x]) {
            if (used[e]) {
                pa = -1e9;
            }
            used[e] = 1;
            pa++;
        }
    }
    sort(sets.begin(), sets.end());
    if (unique(sets.begin(), sets.end()) != sets.end()) {
        quitf(_pe, "not all numbers unique");
    }
    pa = max(0, pa);
    return 1 * 5.0;

}

int main(int argc, char **argv)
{
    registerTestlibCmd(argc, argv);
    int t = inf.readInt(1, 70, "t");
    double score = 0;
    while (t--) {
        score += score_test();
    }
    quitf(_ok, "participants solution is ok");

    return 0;
} 