#include <vector>
#include <string>
#include <set>
#include "testlib.h"
#include <iostream>
using namespace std;


int main(int argc, char **argv)
{
    registerTestlibCmd(argc, argv);
    // if ()
    int n = inf.readInt();
	vector <string> words(n);
	for (int i = 0; i < n; ++i)
		words[i] = inf.readWord();
	string os = ouf.readWord();
	for (int i = 0; i < n; ++i)
		if (os.find(words[i]) == -1)
			quitf(_wa, "%s not in participant string", words[i].c_str());
	string as = ans.readWord();
	if (os.size() < as.size())
		quitf(_fail, "better than jury answer");
	double msc = 30.0;
	double p = 1.0 * as.size() / os.size();
	p = p * p * p * p * p;
	quitp(msc * p, "Participant solution is ok");

    return 0;
} 