#include <vector>
#include <string>
#include <set>
#include "testlib.h"
#include <iostream>
#include <set>
using namespace std;

int main(int argc, char **argv)
{
  registerTestlibCmd(argc, argv);
  int n = inf.readInt();
  vector <vector <int>> tab(n + 2);
  for (int i = 0; i < n + 2; ++i)
	  tab[i].resize(n + 2, 0);
  for (int i = 1; i < n + 1; ++i) {
	  for (int j = 1; j < n + 1; ++j)
		  tab[i][j] = ouf.readInt();
  }
  vector <int> dx = {-1, 0, 1, -1, 0, 1, -1, 0, 1};
  vector <int> dy = {-1, -1, -1, 0, 0, 0, 1, 1, 1};
  int posans;
  bool flag = true;
  for (int i = 1; i < n + 1; ++i) {
	  for (int j = 1; j < n + 1; ++j) {
		  posans = inf.readInt();
		  int realans = 0;
		  for (int k = 0; k < 9; ++k)
			  realans += tab[i + dy[k]][j + dx[k]];
		  if (posans != realans)
			  flag = false;
	  }
  }
  if (flag)
	  quitp(70.0, "participant's solution is ok");
  else
	  quitf(_wa, "wa");
  //quitf(_ok, "precheck ok");
	  

  return 0;
}
